/* 
 Test of display software
 - set up a typing test
 - run for 15 seconds, counting the number of characters entered
*/
#include <stdlib.h>
#include <dos.h>

#include "..\os.h"
#include "module2.h"
#include "..\module1\module1.h"

#define TEST_LENGTH	15  /* seconds */

/* Stacks for running process and interrupt tasks */

STACK running_stk;
STACK *running;
STACK kernel;

unsigned char stack[256];

/* Counters for number of characters and elapsed time */

int char_count;
int time_count;


void main()
{
char total_str[12];  /* ASCII representation of total */
int total;           /* Count of keystrokes */
int col;

running = &running_stk;

running -> ss = _SS;
running -> sp = _SP;

kernel . ss = _DS;
kernel . sp = (unsigned int) &stack[255];

module2_init();

erase_screen();

time_count = TEST_LENGTH;
char_count = 0;

message(0, 0, "Start typing now...");

module1_init();  

enable();	/* Interrupts start now */

while (time_count != 0)    /* or simply !time_count */
	;

total = char_count;  /* Don't count late keystrokes */

col = message(1, 0, "Test has finished!  Total characters: ");

itoa(total, total_str, 10);

message(1, col, total_str);

rtn_to_dos();

}