/***************************************************************************/
/***************************************************************************/
/*                                                                         */
/*              OSLab Module2: Memory Management Header File               */
/*                                                                         */
/***************************************************************************/
/***************************************************************************/

#ifndef MODULE2_H
#define MODULE2_H

/* Memory manager entry points:
 1. module2_init() - initialize memory management 
 2. allocate() - allocate a block of memory
 3. deallocate() - deallocate a block of memory
 4. display() - display a character in a given screen position.
 5. message() - displays a string starting at [row, col]
 6. erase_screen() - clears the screen
 7. display_init() - initialize the display routine.
 8. memmgr_init() - initialize the memory lists
 9. scroll_region() - scroll a given region
*/

void module2_init(void);
void *allocate(unsigned size);
int deallocate(void *ptr);

int message(int row, int col, char *str);
void erase_screen(void);
void display(int line, int col, char ch);

void display_init(void);
void memmgr_init(void);

void scroll_region(int uly, int ysz, int ulx, int xsz);

#endif